#include "WorkingTreeFile.h"
#include <stdio.h>
#include <stdlib.h>

void PP0(struct TREE *);
void PP1(struct TREE *);
struct TREE *FindMin(struct TREE *);
struct TREE *FindMinPlace(struct TREE *);

int main()
{   int n2;
    WCHAR *ws2;
    struct TREE *Zmin,*Zplace;

    ROOT=(struct TREE *)OpenTreeFile(L"Tree1.tre", &Setting);
    Setting>>=11;
/*  Setting=1 -   
    Setting=2 -   
    Setting=3 -   
    Setting=4 -      */

    if(Setting==1 || Setting==3)
    {   DelTree();
        return 0;
    }

    if(Setting==2) PP0(ROOT);

    do
    {   Zmin=FindMin(ROOT); 
        if(Zmin)
    	{   Zplace=FindMinPlace(ROOT);
            if(Zmin!=Zplace)
            {   if(Setting==4)  /* strings tree  */ 
                {   ws2=Zmin->ws;
                    Zmin->ws=Zplace->ws;
                    Zplace->ws=ws2;
                }
                n2=Zmin->n;
                Zmin->n=Zplace->n;
                Zplace->n=n2;
            }
            if(Setting==2) Zplace->ws=(WCHAR *)GlobalAlloc(0,2);
            else Zplace->n |= 128;
        }
    } while(Zmin);
    PP1(ROOT);
    UpdateTree(ROOT,Setting-1);
    DelTree();
    return 0;
}

/******************** scan Tree **************************************/

void PP0(struct TREE *Z)
{   Z->ws=NULL;
    if(Z->Left) PP0(Z->Left);
    if(Z->Right) PP0(Z->Right);
}

void PP1(struct TREE *Z)
{   if(Setting==2 && Z->ws)
    {   GlobalFree(Z->ws);
        Z->ws=NULL;
    }
    if(Setting==4 && (Z->n & 128)) Z->n &= 127;
    if(Z->Left) PP1(Z->Left);
    if(Z->Right) PP1(Z->Right);
}

struct TREE *FindMin(struct TREE *Z)
{   struct TREE *MinL=NULL,*MinR=NULL;

    if(Z->Left) MinL=FindMin(Z->Left);
    if(Z->Right) MinR=FindMin(Z->Right);

    if(Setting==2)  /*  numbers tree  */
    {   if(MinR && (MinL==NULL || MinL->n>MinR->n)) MinL=MinR;
        if(Z->ws==NULL && (MinL==NULL || MinL->n>Z->n)) MinL=Z;
    }
    else    /*  Setting==4 - strings tree  */ 
    {   if(MinR && (MinL==NULL || lstrcmpW(MinL->ws,MinR->ws)>0)) MinL=MinR;
        if((Z->n & 128)==0 && (MinL==NULL || lstrcmpW(MinL->ws,Z->ws)>0)) MinL=Z;
    }
    return MinL;
}

struct TREE *FindMinPlace(struct TREE *Z)
{   struct TREE *MinPlace;

    if(Z->Left)
    {   MinPlace=FindMinPlace(Z->Left);
        if(MinPlace) return MinPlace;
    }
    
    if(Setting==2 && Z->ws==NULL) return Z;
    if(Setting==4 && (Z->n & 128)==0) return Z;
     
    if(Z->Right) return FindMinPlace(Z->Right);
    return NULL;
}
