#include "WorkingTreeFile.h"
#include <stdio.h>
#include <stdlib.h>

#include <string.h>
#include <math.h>

short k=0;

double MyTreeScanning(struct TREE *);
double StringToNumber(WCHAR *ws);

int main()
{   char M[2000];
    double x;    

    ROOT=(struct TREE *)OpenTreeFile(L"Tree1.tre",&Setting);
    Setting>>=11;
    x=MyTreeScanning(ROOT);
    sprintf(M,"%f",x);
    ResultFile(M,0);
    DelTree();
    return 0;
}

/****************** scan Tree **************************/

double StringToNumber(WCHAR *ws)
{   double x=0,j=10;
    int i=0;
    WCHAR *ws1=ws;

    while(*ws1)
    {   if(*ws1==L'.')
        {   if(i)
            {   wprintf(L"\r\nError in number: %c\r\n",*ws1);
                k=1;
                return 0;
            }
            i=1;
        }
        else if(*ws1<L'0' || L'9'<*ws1)
        {   wprintf(L"\r\nError in number: %c\r\n",*ws1);
            k=1;
            return 0;
        }
        else
        {   if(i)
            {   x=x+(*ws1-L'0')/j;
                j*=10;
            } 
            else x=10*x+*ws1-L'0';
        }
        ++ws1;
    }
    return x;
}

double MyTreeScanning(struct TREE *Z)
{   double x,y;
    int i=0;

    if(k) return 0;
    if((Z->Left && Z->Right==NULL) || (Z->Left==NULL && Z->Right))
    {   printf("\n\tError in node %s\n",Z->ws);
        return 0;
    }
    if(Z->Left && Z->Right)
    {   if(*(Z->ws)==L'+') i=1;
        if(i==0 && *(Z->ws)==L'-') i=2;
        if(i==0 && *(Z->ws)==L'*') i=3;
        if(i==0 && *(Z->ws)==L'/') i=4;
        if(i==0 && *(Z->ws)==L'^') i=5;
        if(i==0)
        {   wprintf(L"\r\nError in node %s\r\n",Z->ws);
            k=1;
            return 0;
        }
        
        x=MyTreeScanning(Z->Left);
        y=MyTreeScanning(Z->Right);
        if(i==1) return x+y;
        if(i==2) return x-y;
        if(i==3) return x*y;
        if(i==4)
        {   if(y) return x/y; 
            wprintf(L"\r\nError: division by zero in node %s\r\n",Z->ws);
            k=1;
            return 0;
        }
        if(i==5)
        {   if(0<x) return pow(x,y);
            if(x==0)
            {   if(y<=0)
                {   wprintf(L"\r\nError: negative degree of 0 in node %s\r\n",Z->ws);
                    k=1;
                }
                return 0;
            }
            if(x<0)
            {   if((double)((int)(y))!=y)
                {   wprintf(L"\r\nError: negative number in non-integral degree in node %s\r\n",Z->ws);
                    k=1;
                    return 0;
                }
                i=(int)y;
                if(((i>>1)<<1)==i) return pow(-x,(double)i);
                else return -pow(-x,(double)i); 
            }
        }
    }
    return StringToNumber(Z->ws);
}

/***********************************************************/
